package main

import (
	"fmt"
	"log"
	"math/rand"
	"time"

	"gitea.voser.cloud/Container/iwilldie/src/api"
	"gitea.voser.cloud/Container/iwilldie/src/helper"
	"github.com/gin-gonic/gin"
)

func main() {
	helper.Loadenv()
	helper.Printenv()
	start_death_timer()
	start_server()

	stop_server()
}

// Start Server
func start_server() {
	fmt.Printf("\nStart Server now\n")
	gin.SetMode(gin.ReleaseMode)
	router := gin.Default()
	// Favicon
	router.StaticFile("/favicon.ico", "./assets/favicon.ico")
	// Return the current health of the container (OK => Healthy)
	router.GET("/api/health", api.GET_health)
	// Return the current config for the container (TTL, Max/Min TTL, Hardfail, IP, Hostname)
	router.GET("/api/status", api.GET_status)
	// Start Router
	router.Run("127.0.0.1:8000")
}

// Start Death Timer
func start_death_timer() {

	// initialize the random number generator with the current time
	rand.Seed(time.Now().UnixNano())

	// generate a random integer between 1 and 10
	delta_ttl := helper.MAX_TTL - helper.MIN_TTL
	helper.TTL = rand.Intn(helper.MIN_TTL) + delta_ttl
	fmt.Printf("The TTL for this instance was set to %d seconds", helper.TTL)
	go func() {
		for {
			time.Sleep(time.Second)
			helper.TTL--
			if helper.TTL == 0 {
				api.Server_Status = "Unhealthy"
				log.Printf("Server Staus change to %s", api.Server_Status)
				if helper.HARDFAIL != true {
					for {
						time.Sleep(time.Second)
						helper.HARDFAIL_DELAY--
						if helper.HARDFAIL_DELAY == 0 {
							log.Fatal("Hardfail was set to false")
						}
					}
				} else {
					log.Panic("Hardfail was set to true")
				}
			}
		}
	}()
}

// Stop Server
func stop_server() {
	fmt.Println("Stop Server now")
}
